﻿DECLARE @id AS INT = 1;
SET IDENTITY_INSERT [dbo].[PerformanceThresholds] ON;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'CPU', N'CPU-Auslastung (%)', 70, 85, N'ROT ≥ 85, GELB ≥ 70', N'CPU-Auslastung prüfen. Hohe Werte deuten auf rechenintensive Prozesse oder fehlende Indizes hin.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'RAM', N'RAM-Auslastung (%)', 70, 85, N'ROT ≥ 85, GELB ≥ 70', N'RAM prüfen. Speicherengpässe können zu Page I/O und Performanceverlust führen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'IO_Read', N'Lesen Datenbankdateien (Millisekunden)', 10, 20, N'ROT ≥ 20, GELB ≥ 10', N'I/O-Latenz zu hoch. Überprüfe Storage, Autogrowth-Ereignisse und große Abfragen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'IO_Write', N'Schreiben Datenbankdateien (Millisekunden)', 10, 20, N'ROT ≥ 20, GELB ≥ 10', N'I/O-Latenz zu hoch. Überprüfe Storage, Autogrowth-Ereignisse und unnötige Indizes.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'TempDBRead', N'Lesen TempDB (Millisekunden)', 10, 20, N'ROT ≥ 20, GELB ≥ 10', N'TempDB-Leselatenz prüfen. Mehr Dateien und schneller Storage können helfen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'TempDBWrite', N'Schreiben TempDB (Millisekunden)', 10, 20, N'ROT ≥ 20, GELB ≥ 10', N'TempDB-Schreiblatenz hoch. Autogrowth verhindern, SSD einsetzen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'WaitStats', N'Wartestatistiken (Millisekunden)', 10, 20, N'ROT ≥ 20, GELB ≥ 10', N'Wait-Typen analysieren. Hohe Waits deuten auf Systemengpässe oder Blockierungen hin.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'Pressure', N'RAM-Pressure (J/N), Grants (J/N) ', 1, 11, N'ROT ≥ 2, GELB ≥ 1', N'RAM-Druck entsteht durch hohe Memory-Grants oder Sorts. Query-Tuning empfohlen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'SessionsTotal', N'Sitzungen-Gesamt', 100, 250, N'ROT ≥ 250, GELB ≥ 100', N'.NET-Verbindungen schließen (using-Statement nutzen). Application-Pooling prüfen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'SessionsRunning', N'Sitzungen-Aktiv', 30, 80, N'ROT ≥ 80, GELB ≥ 30', N'Bei anhaltend hoher CPU-Last einzelne Datenbanken emigrieren.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'Query', N'Query-Dauer (Millisekunden)', 1, 5, N'ROT ≥ 5, GELB ≥ 1', N'Queries optimieren per sys.dm_exec_query_stats. Ggbf. fehlende Indizes anlegen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'IndexMissing', N'Max. fehlende Indizes pro Datenbank', 5, 10, N'ROT ≥ 10, GELB ≥ 5', N'Fehlende Indizes anlegen. Auszuschließende Indizes in Blacklist aufnehmen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'IndexUnnecessary', N'Max. unnötige Indizes pro Datenbank', 5, 10, N'ROT ≥ 10, GELB ≥ 5', N'Unnötige Indizes prüfen und entfernen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'Statistics', N'Veraltete Statistiken pro Datenbank', 5, 10, N'ROT ≥ 10, GELB ≥ 5', N'Wartungspläne prüfen. Statistiken für ausgewählte Datenbanken häufiger aktualisieren.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint])
VALUES (@id, N'IndexDuplicates', N'Index-Duplikate pro Datenbank', 3, 6, N'ROT ≥ 6, GELB ≥ 3', N'Indizes konsolidieren. Häufiger genutzten Index beibehalten, evtl. umbenennen.');
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint], [InverseLogic])
VALUES (@id, N'PlanCache', N'Execution-Plan-Cache-Wiederverwendung (%)', 80, 50, N'ROT < 50, GELB < 80', N'Server nicht wiederholt neustarten. Queries optimieren.', 1);
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint], [InverseLogic])
VALUES (@id, N'Uptime', N'Uptime (Tage)', 80, 50, N'ROT < 7, GELB < 14', N'Ausführungspläne werden bei jedem Neustart verworfen. Geringe Update führt zu schlechten Plänen.', 1);
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint], [InverseLogic])
VALUES (@id, N'Heap', N'Heaps pro Datenbank', 3, 5, N'ROT >= 5, GELB >= 3', N'Tabellen benötigen Clustered Index (Primärschlüssel); sonst drastische Performanz-Probleme.', 0);
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint], [InverseLogic])
VALUES (@id, N'IndexFillFactor', N'Indizes mit Füllfaktor < 100% pro Datenbank (%)', 10, 30, N'ROT ≥ 30, GELB ≥ 10', N'Füllfaktor für Indizes serverweit auf 100 setzen. Index-Rebuilds ausführen.', 0);
SET @id = @id + 1;

IF NOT EXISTS (SELECT 1 FROM [dbo].[PerformanceThresholds] WHERE [Id] = @id)
INSERT INTO [dbo].[PerformanceThresholds] ([Id],[MetricName],[MetricText],[YellowThreshold],[RedThreshold],[Description],[Hint], [InverseLogic])
VALUES (@id, N'Vss', N'Freezes pro VSS-Backup (Sekunden)', 5, 10, N'ROT ≥ 10, GELB ≥ 5', N'Datendateien auf mehrer Storage-Volumes verteilen. Niemals mehr als 35 Datenbanken pro Volume zeitgleich sichern.', 0);
SET @id = @id + 1;

SET IDENTITY_INSERT [dbo].[PerformanceThresholds] OFF;
GO
