GO
CREATE OR ALTER FUNCTION [dbo].[GetTrafficLightIndicatorStringByMetric]
(
    @MetricName NVARCHAR(MAX),
    @Value INT
)
RETURNS NVARCHAR(10)
AS
BEGIN
    DECLARE 
        @YellowThreshold INT,
        @RedThreshold INT,
        @InverseLogic BIT,
        @Result NVARCHAR(10);

    SELECT 
        @YellowThreshold = YellowThreshold,
        @RedThreshold = RedThreshold,
        @InverseLogic = InverseLogic
    FROM dbo.PerformanceThresholds
    WHERE MetricName = @MetricName;

    SET @Result = 
        CASE 
            WHEN @Value IS NULL THEN '-'
            WHEN @InverseLogic = 0 THEN
                CASE 
                    WHEN @Value >= @RedThreshold THEN 'ROT'
                    WHEN @Value >= @YellowThreshold THEN 'GELB'
                    ELSE 'GRN'
                END
            ELSE
                CASE 
                    WHEN @Value < @RedThreshold THEN 'ROT'
                    WHEN @Value < @YellowThreshold THEN 'GELB'
                    ELSE 'GRN'
                END
        END;

    RETURN @Result;
END;
GO