GO
CREATE OR ALTER FUNCTION [dbo].[GetTrend]
(
    @OldValue FLOAT,
    @NewValue FLOAT,
    @MetricName NVARCHAR(MAX)
)
RETURNS NVARCHAR(10)
AS
BEGIN
    DECLARE @Trend NVARCHAR(10);
    DECLARE @InverseLogic BIT;

    SET @Trend = N'?';

    SELECT @InverseLogic = InverseLogic
    FROM dbo.PerformanceThresholds
    WHERE MetricName = @MetricName;

    IF @OldValue IS NOT NULL AND @NewValue IS NOT NULL
    BEGIN
        IF @InverseLogic = 0
        BEGIN
            IF @NewValue < @OldValue * 0.95
                SET @Trend = N'POSITIV';
            ELSE IF @NewValue > @OldValue * 1.05
                SET @Trend = N'NEGATIV';
            ELSE
                SET @Trend = N'=';
        END
        ELSE
        BEGIN
            IF @NewValue > @OldValue * 1.05
                SET @Trend = N'POSITIV';
            ELSE IF @NewValue < @OldValue * 0.95
                SET @Trend = N'NEGATIV';
            ELSE
                SET @Trend = N'=';
        END
    END

    RETURN @Trend;
END;
GO