GO
CREATE OR ALTER FUNCTION [dbo].[GetWaitTypeExplanation]
(
    @WaitType NVARCHAR(100),
    @ReadsInMs FLOAT
)
RETURNS NVARCHAR(MAX)
AS
BEGIN
    DECLARE @Explanation NVARCHAR(MAX);

    IF @ReadsInMs IS NULL OR @ReadsInMs < 10
        SET @Explanation = N'WaitType [' + ISNULL(@WaitType, N'n/a') + N']: Wert < 10 ms  Analyse ggf. nicht aussagekrftig.';
    ELSE
        SET @Explanation =
            CASE 
                WHEN @WaitType LIKE N'PAGEIOLATCH%' THEN 
                    N'WaitType [' + @WaitType + N']: Langsame I/O-Zugriffe (' + CAST(ROUND(@ReadsInMs, 2) AS NVARCHAR) + N' ms). Indexe prfen, Storage optimieren.'
                WHEN @WaitType LIKE N'IO_%' THEN 
                    N'WaitType [' + @WaitType + N']: I/O-Subsystem ausgelastet (' + CAST(ROUND(@ReadsInMs, 2) AS NVARCHAR) + N' ms). Dateien verteilen, schnelleren Storage verwenden.'
                WHEN @WaitType LIKE N'LCK_%' THEN 
                    N'WaitType [' + @WaitType + N']: Blockierungen (' + CAST(ROUND(@ReadsInMs, 2) AS NVARCHAR) + N' ms). Transaktionen verkrzen, Indexe prfen.'
                WHEN @WaitType = N'RESOURCE_SEMAPHORE' THEN 
                    N'WaitType [' + @WaitType + N']: RAM reicht nicht. Groe Abfragen prfen, Speicher erhhen.'
                WHEN @WaitType = N'THREADPOOL' THEN 
                    N'WaitType [' + @WaitType + N']: Nicht genug Worker Threads. MAXDOP anpassen, Abfragen parallelisieren.'
                WHEN @WaitType LIKE N'CX%' THEN 
                    N'WaitType [' + @WaitType + N']: Parallelisierung ineffizient. MAXDOP, Statistiken prfen.'
                ELSE 
                    N'WaitType [' + @WaitType + N']: Nicht klassifizierter WaitType (' + CAST(ROUND(@ReadsInMs, 2) AS NVARCHAR) + N' ms).'
            END;

    RETURN @Explanation;
END;
GO
