/*
Decription
This script is optimized for production SQL Server with:
- 8 CPU cores, HDD storage, ~10 DBs (~40GB total)
- Moderate workload, 8 tempdb data files
- Ensures balanced I/O and stable tempdb growth 

History
2025.04.07 | GRI | Script Creation

Contact
florian.grieme@gmx.de

Dependencies
SQL Server restart required to apply changes
*/

USE [master];
GO

-- tempdbs
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'tempdev',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp2',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp3',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp4',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp5',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp6',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp7',   SIZE = 1024MB, FILEGROWTH = 256MB);
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'temp8',   SIZE = 1024MB, FILEGROWTH = 256MB);

-- templog
ALTER DATABASE [tempdb] MODIFY FILE (NAME = N'templog', SIZE = 2048MB, FILEGROWTH = 512MB);
