SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE OR ALTER PROCEDURE [dbo].[GetCpuPercentageUsed]
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE @PercentageUsedServer INT;

    SELECT TOP 1
        @PercentageUsedServer = 100 - CAST(x.XmlRecord.value('(./Record/SchedulerMonitorEvent/SystemHealth/SystemIdle)[1]', 'INT') AS INT)
    FROM sys.dm_os_ring_buffers AS rb
    CROSS APPLY (SELECT CAST(rb.record AS XML) AS XmlRecord) AS x
    WHERE rb.ring_buffer_type = N'RING_BUFFER_SCHEDULER_MONITOR'
      AND rb.record LIKE '%<SystemHealth>%'
    ORDER BY rb.timestamp DESC;

    INSERT INTO dbo.Cpu (PercentageUsedServer)
    VALUES (@PercentageUsedServer);
END;
GO