SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE OR ALTER PROCEDURE [dbo].[GetRamPressure]
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE 
        @Pressure BIT,
        @GrantsPending INT;

    SELECT @Pressure = process_physical_memory_low
    FROM sys.dm_os_process_memory;

    SELECT @GrantsPending = COUNT(*)
    FROM sys.dm_exec_query_memory_grants
    WHERE grant_time IS NULL;

    INSERT INTO dbo.RamPressure (Pressure, GrantsPending)
    VALUES (@Pressure, @GrantsPending);
END;
GO