SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE OR ALTER PROCEDURE [dbo].[GetTempDbIo]
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE 
        @AvgReadMs INT,
        @AvgWriteMs INT;

    SELECT
        @AvgReadMs = AVG(CAST(io_stall_read_ms * 1.0 / NULLIF(num_of_reads, 0) AS INT)),
        @AvgWriteMs = AVG(CAST(io_stall_write_ms * 1.0 / NULLIF(num_of_writes, 0) AS INT))
    FROM sys.dm_io_virtual_file_stats(DB_ID(N'tempdb'), NULL) vfs
    JOIN sys.master_files mf 
        ON mf.database_id = vfs.database_id AND mf.file_id = vfs.file_id
    WHERE mf.database_id = 2;

    IF @AvgReadMs IS NOT NULL AND @AvgWriteMs IS NOT NULL
    BEGIN
        INSERT INTO dbo.TempDbIo (AvgReadMs, AvgWriteMs)
        VALUES (@AvgReadMs, @AvgWriteMs);
    END
END;
GO