SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE OR ALTER PROCEDURE [dbo].[GetWaits]
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE 
        @WaitType NVARCHAR(100),
        @AvgWaitMs INT;

    SELECT TOP 1
        @WaitType = wait_type,
        @AvgWaitMs = CAST(wait_time_ms * 1.0 / NULLIF(waiting_tasks_count, 0) AS INT)
    FROM sys.dm_os_wait_stats
    WHERE wait_type NOT IN (
        'SLEEP_TASK','LAZYWRITER_SLEEP','RESOURCE_QUEUE','WAITFOR','LOGMGR_QUEUE',
        'REQUEST_FOR_DEADLOCK_SEARCH','SQLTRACE_BUFFER_FLUSH','CLR_SEMAPHORE','CLR_AUTO_EVENT',
        'XE_TIMER_EVENT','XE_DISPATCHER_WAIT','BROKER_RECEIVE_WAITFOR','BROKER_TASK_STOP',
        'BROKER_EVENTHANDLER','DISPATCHER_QUEUE_SEMAPHORE','FT_IFTS_SCHEDULER_IDLE_WAIT',
        'FT_IFTSHC_MUTEX','HADR_FILESTREAM_IOMGR_IOCOMPLETION','HADR_WORK_QUEUE',
        'KSOURCE_WAKEUP','PREEMPTIVE_OS_GETPROCADDRESS','PREEMPTIVE_OS_AUTHENTICATIONOPS',
        'PREEMPTIVE_OS_GENERICOPS','PREEMPTIVE_OS_WAITFORSINGLEOBJECT','WAIT_XTP_HOST_WAIT',
        'SP_SERVER_DIAGNOSTICS_SLEEP'
    )
    ORDER BY wait_time_ms DESC;

    IF @WaitType IS NOT NULL AND @AvgWaitMs IS NOT NULL
    BEGIN
        INSERT INTO dbo.Wait (WaitType, AvgWaitMs)
        VALUES (@WaitType, @AvgWaitMs);
    END
END;
GO