SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE OR ALTER PROCEDURE [dbo].[GetQueries]
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE @avg_ms INT;

    SELECT @avg_ms = CEILING(
        CAST(SUM(total_elapsed_time) AS FLOAT) / NULLIF(SUM(execution_count), 0) / 1000.0
    )
    FROM sys.dm_exec_query_stats
    WHERE execution_count > 0;

    IF @avg_ms IS NULL SET @avg_ms = 0;

    INSERT INTO dbo.[Query] (Average)
    VALUES (@avg_ms);
END
GO