SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE OR ALTER PROCEDURE [dbo].[GetPlanCache]
AS
BEGIN
    SET NOCOUNT ON;

    DECLARE 
        @Reuse INT,
        @Uptime INT;

    SELECT 
        @Reuse = CEILING(
            (SELECT COUNT(*) * 1.0 
             FROM sys.dm_exec_cached_plans 
             WHERE usecounts > 1 AND cacheobjtype = 'Compiled Plan')
            /
            NULLIF(
                (SELECT COUNT(*) * 1.0 
                 FROM sys.dm_exec_cached_plans 
                 WHERE cacheobjtype = 'Compiled Plan'), 0
            ) * 100
        ),
        @Uptime = DATEDIFF(DAY, sqlserver_start_time, GETDATE())
    FROM sys.dm_os_sys_info;

    IF @Reuse IS NULL SET @Reuse = 0;

    INSERT INTO dbo.PlanCache (Reuse, Uptime)
    VALUES (@Reuse, @Uptime);
END
GO