SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE OR ALTER PROCEDURE [dbo].[sp_CleanupTelemetryData]
    @CutoffDate DATETIME2(0) = NULL
AS
BEGIN
    SET NOCOUNT ON;

    IF @CutoffDate IS NULL
        SET @CutoffDate = DATEADD(YEAR, -1, GETDATE());

    PRINT 'Lsche Daten vor ' + CONVERT(NVARCHAR(20), @CutoffDate, 120);

    DELETE FROM dbo.Cpu
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.Heap
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.IndexDuplicates
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.IndexFillFactor
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.IndexMissing
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.IndexUnnecessary
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.[Io]
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.PlanCache
    WHERE [Date] < @CutoffDate

    DELETE FROM dbo.Query
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.Ram
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.RamPressure
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.[Session]
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.[Statistics]
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.TempDbIo
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.Vss
    WHERE [Date] < @CutoffDate;

    DELETE FROM dbo.Wait
    WHERE [Date] < @CutoffDate;

    PRINT 'Bereinigung abgeschlossen.';
END;
GO