/*
Decription
Installs all necessary tables, spc's, scalar-functions and jobs for PerfGuard

Revision History
2025.04.04 | GRI | Script Creation

Point of Contact
florian.grieme@gmx.de

Dependencies
-
*/

PRINT 'Step Tbl_010: Erstelle Tabelle Cpu';
:r Tbl_010_Cpu.sql
PRINT 'Step Tbl_020: Erstelle Tabelle Io';
:r Tbl_020_Io.sql
PRINT 'Step Tbl_030: Erstelle Tabelle PerformanceThresholds';
:r Tbl_030_PerformanceThresholds.sql
PRINT 'Step Tbl_040: Erstelle Tabelle Ram';
:r Tbl_040_Ram.sql
PRINT 'Step Tbl_050: Erstelle Tabelle RamPressure';
:r Tbl_050_RamPressure.sql
PRINT 'Step Tbl_060: Erstelle Tabelle TempDbIo';
:r Tbl_060_TempDbIo.sql
PRINT 'Step Tbl_070: Erstelle Tabelle Session';
:r Tbl_070_Session.sql
PRINT 'Step Tbl_080: Erstelle Tabelle Wait';
:r Tbl_080_Wait.sql
PRINT 'Step Tbl_090: Erstelle Tabelle WhiteListWaitType';
:r Tbl_090_WhiteListWaitType.sql
PRINT 'Step Tbl_110: Erstelle Tabelle Query';
:r Tbl_110_Query.sql
PRINT 'Step Tbl_120: Erstelle Tabelle IndexMissing';
:r Tbl_120_IndexMissing.sql
PRINT 'Step Tbl_130: Erstelle Tabelle BlackListIndexTable';
:r Tbl_130_BlackListIndexTable.sql
PRINT 'Step Tbl_140: Erstelle Tabelle IndexUnnecessary';
:r Tbl_140_IndexUnnecessary.sql
PRINT 'Step Tbl_150: Erstelle Tabelle Statistics';
:r Tbl_150_Statistics.sql
PRINT 'Step Tbl_160: Erstelle Tabelle IndexDuplicates';
:r Tbl_160_IndexDuplicates.sql
PRINT 'Step Tbl_170: Erstelle Tabelle PlanCache';
:r Tbl_170_PlanCache.sql
PRINT 'Step Tbl_180: Erstelle Tabelle Heap';
:r Tbl_180_Heap.sql
PRINT 'Step Tbl_190: Erstelle Tabelle BlackListHeapTable';
:r Tbl_190_BlackListHeapTable.sql
PRINT 'Step Tbl_200: Erstelle Tabelle Vss';
:r Tbl_200_Vss.sql
PRINT 'Step Tbl_210: Erstelle Tabelle IndexFillFactor';
:r Tbl_210_IndexFillFactor.sql
PRINT '-------------------------------------------------------------------------------------------';
PRINT 'Step Dat_030: Generiere Vorgabe-Werte InsertPerformanceThresholds';
:r Dat_030_InsertPerformanceThresholds.sql
PRINT 'Step Dat_090: Generiere Vorgabe-Werte InsertWhiteListWaitType';
:r Dat_090_InsertWhiteListWaitType.sql
PRINT 'Step Dat_190: Generiere Vorgabe-Werte InsertBlackListHeapTable';
:r Dat_190_InsertBlackListHeapTable.sql
PRINT '-------------------------------------------------------------------------------------------';
PRINT 'Step Sca_010: Erstelle Skalarwert-Funktion GetHintByMetricName';
:r Sca_010_GetHintByMetricName.sql
PRINT 'Step Sca_020: Erstelle Skalarwert-Funktion GetMetricDescriptionByMetric';
:r Sca_020_GetMetricDescriptionByMetric.sql
PRINT 'Step Sca_030: Erstelle Skalarwert-Funktion GetTrafficLightIndicatorStringByMetric';
:r Sca_030_GetTrafficLightIndicatorStringByMetric.sql
PRINT 'Step Sca_040: Erstelle Skalarwert-Funktion GetTrend';
:r Sca_040_GetTrend.sql
PRINT 'Step Sca_050: Erstelle Skalarwert-Funktion GetWaitTypeExplanation';
:r Sca_050_GetWaitTypeExplanation.sql
PRINT 'Step Sca_060: Erstelle Skalarwert-Funktion GetMetricTextByMetricName';
:r Sca_060_GetMetricTextByMetricName.sql
PRINT '-------------------------------------------------------------------------------------------';
PRINT 'Step Spc_010: Erstelle Gepseicherte Prozedur GetCpuPercentageUsed';
:r Spc_010_GetCpuPercentageUsed.sql
PRINT 'Step Spc_020: Erstelle Gepseicherte Prozedur sp_LogIo';
:r Spc_020_GetIo.sql
PRINT 'Step Spc_040: Erstelle Gepseicherte Prozedur GetRamPercentageUsed';
:r Spc_040_GetRamPercentageUsed.sql
PRINT 'Step Spc_050: Erstelle Gepseicherte Prozedur GetRamPressure';
:r Spc_050_GetRamPressure.sql
PRINT 'Step Spc_060: Erstelle Gepseicherte Prozedur GetTempDbIo';
:r Spc_060_GetTempDbIo.sql
PRINT 'Step Spc_070: Erstelle Gepseicherte Prozedur GetSessions';
:r Spc_070_GetSessions.sql
PRINT 'Step Spc_080: Erstelle Gepseicherte Prozedur GetWaits';
:r Spc_080_GetWaits.sql
PRINT 'Step Spc_100: Erstelle Gepseicherte Prozedur GetQueries';
:r Spc_100_GetQueries.sql
PRINT 'Step Spc_120: Erstelle Gepseicherte Prozedur GetIndexesMissing';
:r Spc_120_GetIndexesMissing.sql
PRINT 'Step Spc_130: Erstelle Gepseicherte Prozedur GetIndexesUnnecessary';
:r Spc_130_GetIndexesUnnecessary.sql
PRINT 'Step Spc_150: Erstelle Gepseicherte Prozedur GetStatistics';
:r Spc_150_GetStatistics.sql
PRINT 'Step Spc_160: Erstelle Gepseicherte Prozedur GetIndexDuplicates';
:r Spc_160_GetIndexDuplicates.sql
PRINT 'Step Spc_170: Erstelle Gepseicherte Prozedur GetPlanCache';
:r Spc_170_GetPlanCache.sql
PRINT 'Step Spc_180: Erstelle Gepseicherte Prozedur GetHeaps';
:r Spc_180_GetHeaps.sql
PRINT 'Step Spc_200: Erstelle Gepseicherte Prozedur GetFreezes';
:r Spc_200_GetFreezes.sql
PRINT 'Step Spc_210: Erstelle Gepseicherte Prozedur GetIndexFillFactor';
:r Spc_210_GetIndexFillFactor.sql
PRINT 'Step Spc_800: Erstelle Gepseicherte Prozedur PerfGuardDashboard';
:r Spc_800_PerfGuardDashboard.sql
PRINT 'Step Spc_900: Erstelle Gepseicherte Prozedur sp_CleanupTelemetryData';
:r Spc_900_sp_CleanupTelemetryData.sql
PRINT '-------------------------------------------------------------------------------------------';
PRINT 'Step Job_010: Erstelle Agentenjob MaintenanceGetPerformanceIndicatorsForPerfguard';
:r Job_010_MaintenanceGetPerformanceIndicatorsForPerfguard.sql
PRINT '-------------------------------------------------------------------------------------------';